<?PHP


$dbhost = 'localhost';
$dbuser = 'root';
$dbpassword = "";
$dbdatabase = 'domainscope';

$db = mysqli_connect($dbhost,$dbuser,$dbpassword,$dbdatabase);

if (mysqli_connect_errno())
  {
  echo "Failed to connect to MySQL: " . mysqli_connect_error();
  }


    // see DomainScope API documentation - https://domainscope.com/docs/api21
    // Top Popular Keywords API

    // HARDCODED DATES
    //$start_date = '2020-02-01';
    //$end_date = '2020-02-29';

    // DYNAMIC DATES
    $start_date = date("Y-m-d", strtotime("first day of previous month"));
    $end_date = date("Y-m-d", strtotime("last day of previous month"));

    // API URL REQUEST
    $url = "https://domainscope.com/api/v2.1/keywords/popularity/top?";
    $url .= "start_date=$start_date&end_date=$end_date";

    // SET KEY CREDENTIALS
    $header = array(
        'Accept: application/json',
        'X-DOMAINSCOPE-APIKEY: XXXXXXXXXXXXXXXXX' 
    );

    // MAKE CURL CALL
    $ch = curl_init();
    $timeout=60;

    //set the url and other options for curl
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);  
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET'); // Values: GET, POST, PUT, DELETE, PATCH, UPDATE 
    //curl_setopt($ch, CURLOPT_POSTFIELDS, $variable);
    //curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);

    //execute call and return response data.
    $result = curl_exec($ch);

    //close curl connection
    curl_close($ch);


    //$dn = $result;

    // decode the json response
    $dn = json_decode($result, true);

   // echo '<pre>';
   // print_r($dn);
   // echo '</pre>';

    // PREPARE OUTPUT FOR SCREEN DISPLAY

    echo "Time Period: $start_date through $end_date.<br>";

    foreach($dn as $keyword){
        foreach($keyword as $eachKeyword){

            $eachKeyword['date'] = $start_date; // set the date as value for keyword and adding to array at date key

            echo $eachKeyword['keyword'].'<br>';

            // CHECK IF KEYWORD ALREADY EXISTS FOR GIVEN MONTH
            $chk_results = checkKeywordData($eachKeyword);

            if($chk_results){

                // UPDATE EXISTING KEYWORD FOR GIVEN MONTH
                $upd_results = updateKeywordData($eachKeyword);

                if($upd_results){
                    echo '<b>'.$eachKeyword['keyword'].'</b> was updated.<br>';
                } else {
                    echo '<b>'.$eachKeyword['keyword'].'</b> was NOT updated.<br>';
                }

            } else {

                // INSERT KEYWORD FOR GIVEN MONTH
                $ins_results = insertKeywordData($eachKeyword);

                if($ins_results){
                    echo '<b>'.$eachKeyword['keyword'].'</b> was inserted.<br>';
                } else {
                    echo '<b>'.$eachKeyword['keyword'].'</b> was NOT inserted.<br>';
                }

            }

        }
    }



/************************************************************
***** FUNCTIONS
************************************************************/

function insertKeywordData($dn){
    
        global $db;

        $ins_keyword = $dn['keyword'];
        $ins_total_count = $dn['total_count'];
        $ins_com_count = $dn['com_count'];
        $ins_net_count = $dn['net_count'];
        $ins_date = $dn['date'];

    $query = "INSERT into `popkeywords` (`keyword`,`total_count`,`com_count`,`net_count`,`date`) VALUES ('$ins_keyword','$ins_total_count','$ins_com_count','$ins_net_count','$ins_date')";
    
    $msg = false;
    
    if (!mysqli_query($db,$query)){
        echo("Error description: " . mysqli_error($db));
    } else {
        $msg = true;
    }

    return $msg;
    
}

function updateKeywordData($dn){
    
    global $db;

        $upd_keyword = $dn['keyword'];
        $upd_total_count = $dn['total_count'];
        $upd_com_count = $dn['com_count'];
        $upd_net_count = $dn['net_count'];
        $upd_date = $dn['date'];

    $query = "UPDATE `popkeywords` SET `total_count`='$upd_total_count', `com_count`='$upd_com_count', `net_count`='$upd_net_count' where `keyword`='$upd_keyword' and `date`='$upd_date' LIMIT 1";
    
    $msg = false;
    
    if (!mysqli_query($db,$query)){
        echo("Error description: " . mysqli_error($db));
    } else {
        $msg = true;
    }

    return $msg;

}


function checkKeywordData($dn){
    
    global $db;

    $chk_keyword = $dn['keyword'];
    $chk_total_count = $dn['total_count'];
    $chk_com_count = $dn['com_count'];
    $chk_net_count = $dn['net_count'];
    $chk_date = $dn['date'];    
    
    
    $query = "SELECT pkid from `popkeywords` where `keyword`='$chk_keyword' and `date`='$chk_date' limit 1";

    $msg = false;
    
    if (!mysqli_query($db,$query)){
        echo("Error description: " . mysqli_error($db));
    } else {
    
    $q = mysqli_query($db,$query);
    $n = mysqli_num_rows($q);

    if($n > 0 && $dn){
        
        $msg = true;
    }

    }
    
    return $msg;
    
}

?>